
' EViews 7 manual example for long run covariance using HAC
' example data  taken from Stock and Watson, p. 620

' set the estimation sample
smpl 1950m01 2000m12

' create the group of regressors
group xvars fdd(0 to -18) c

' estimate equation with ordinary covariances and get residuals
equation eq_ols.ls 100*dlog(poj) xvars
eq_ols.makeresid res 

' long-run covariance
do xvars.lrcov(rwgt=res, bw=8, out=lrcov, noc) 

' HAC asymptotic coefficient covariance
sym xxinv = @inverse(@inner(xvars))   ' xx inverse
scalar obs = eq_ols.@regobs   ' number of obs
scalar df = obs - eq_ols.@ncoef    ' degrees of freedom
sym hac_direct =  (obs / df ) * obs *  xxinv * lrcov * xxinv

' direct equation HAC estimation
equation eq_hac.ls(cov=hac, covbw=8) 100*dlog(poj) xvars
sym hac_eq  = eq_hac.@coefcov

