' AR1.PRG (1.0 - 6/29/98)
' checked for version 7.0 (11/16/2009)
' example program for EViews LogL object
'
' estimate AR(1) by MLE 
' for a discussion, see pp. 118-119 of Hamilton, James D. (1994) Time Series Analysis, 
' Princeton University Press.
'
' note that this model becomes difficult to estimate as rho approaches 1

' make up data that follows an AR(1), with rho=.85
wfcreate ar1 m 1980 1989
rndseed 123					'set seed of random number generator
series y=0
smpl @first+1 @last
y = 0.85*y(-1) + nrnd


' create dummy variable for first obs
series d1 = 0
smpl @first @first 
d1 = 1
smpl @all


' set starting values to LS (drops first obs)
equation eq1.ls y c ar(1)
coef(1) rho = c(2)
coef(1) s2 = eq1.@se^2


' set up logl object
' uses new @recode syntax: @recode(true_false, value_if_true, value_if_false)
' to handle the first observation likelihood contribution
logl ar1
ar1.append @logl logl1
ar1.append var = @recode( d1=1,s2(1)/(1-rho(1)^2),s2(1) )
ar1.append res = @recode( d1=1,y-c(1)/(1-rho(1)),y-c(1)-rho(1)*y(-1) )
ar1.append sres = res/@sqrt(var)
ar1.append logl1 = log(@dnorm(sres)) -log(var)/2


' do MLE and show results
ar1.ml(showopts,m=1000,c=1e-5)
show ar1.output


' compare with EViews AR(1) estimates which drop the first obs
show eq1.output

' full MLE using state space object
sspace ss1
ss1.append @signal y = c(1) + sv1
ss1.append @state sv1 = c(2)*sv1(-1) + [var = exp(c(3))]
' take starting values from NLS
eq1.updatecoefs
c(3) = log(eq1.@ssr/eq1.@regobs)
ss1.ml(showopts,m=1000,c=1e-5)
show ss1.output
