' ARCH_T1.PRG (1.0 - 6/29/98)
' example program for EViews LogL object
' checked for version 7.0 (11/19/2009)
'
' Estimate GARCH(1,1) model with t-distributed errors
'
' see page 662, equation 21.1.24, of Hamilton, James D. (1994) Time Series Analysis, 
' Princeton University Press.

'change path to program path
%path = @runpath
cd %path

' load workfile
load gerus

series y = 100*dlog(ger)

' set sample to 1/2/82-7/9/92 (10/6/86 is obs 3945)
sample s0 2750 2750
sample s1 2751 5392
smpl s1


' get starting values from Gaussian ARCH
equation eq1
eq1.arch y c 
show eq1.output


' declare and initialize parameters
coef(1) mu = eq1.c(1)
coef(1) omega = eq1.c(2)
coef(1) alpha = eq1.c(3)
coef(1) beta = eq1.c(4)
coef(1) tdf = 3


' set presample values of expressions in logl
smpl s0
series sig2 = omega(1)
series res = 0
!pi = @acos(-1)


' set up GARCH likelihood
logl ll1
ll1.append @logl logl
ll1.append res = y-mu(1)
ll1.append sig2 = omega(1)+alpha(1)*res(-1)^2 +beta(1)*sig2(-1)
ll1.append z = res^2/sig2/(tdf(1)-2) + 1
ll1.append logl = @gammalog((tdf(1) + 1)/2) - @gammalog(tdf(1)/2) - log(!pi)/2 - log(tdf(1) - 2)/2 - log(sig2)/2 - (tdf(1)+1)*log(z)/2


' estimate and display output
smpl s1
ll1.ml(showopts, m=1000, c=1e-5)

'estimate same model using EViews'
' build-in function

equation eq2
eq2.arch(tdist) y c 
show eq2
show ll1.output
