' BOXCOX1.PRG (1.0 - 6/29/98)
' checked for version 7.0 (11/19/2009)
' example program for EViews LogL object

' Box-Cox with transformation on both sides of the equality

' For a description of the likelihood function, see p. 484 of
' Greene, William H. (1997) Econometric Analysis, 3rd edition, 
' Prentice-Hall. See Section 10.4 for a general discussion.

' create workfile
wfcreate boxcox a 1920 1938

' fill data
series y
series x
y.fill 73.8,70.6,59.1,55.5,56,56.4,55.8,56.2,55.7,55.8,55.7,54.9,54,53.7,54.3,55,56.1,57.2,58.9	
x.fill 3.9,17,14.3,11.7,10.3,11.3,12.5,9.7,10.8,10.4,16.1,21.3,22.1,19.9,16.7,15.5,13.1,10.8,12.9

' set starting value for lambda
' NOTE: the estimates are very sensitive to starting values
coef(1) ylam = -0.5
coef(1) xlam = 0.1

' get coef starting values 
series yt = (y^ylam(1)-1)/ylam(1)
series xt = (x^xlam(1)-1)/xlam(1)
equation eq_temp.ls yt c xt
coef(1) var = eq_temp.@se^2

' setup likelihood
logl ll1
ll1.append @logl logl
ll1.append yt = (y^ylam(1)-1)/ylam(1) 
ll1.append xt = (x^xlam(1)-1)/xlam(1) 
ll1.append res = yt-c(1)-c(2)*xt
ll1.append logl = log( @dnorm( res/@sqrt(var(1)) ) ) - log(var(1))/2 + (ylam(1)-1)*log(y)

' do MLE and display results
ll1.ml(showopts, m=1000, c=1e-5)
show ll1.output
