' NLOGIT1.PRG (1.0 - 6/29/98)
' example program for EViews LogL object
' revised for version 5.0 (11/19/2009)
' nested logit with three choices and two branches: 
' branch 1 (y=1) and branch 2 (y=2,3)
'
' for a discussion, see Section 19.7.4 of Greene, William H. (1997) 
' Econometric Analysis, 3rd edition, Prentice-Hall

'change path to program path
%path = @runpath
cd %path

' load artificial data
load mlogit

' declare coef vector to use in MLE
coef(2) a3 = 0.1 ' true values 0.6, -0.3
coef(2) b3 = 0.1 ' true values 0.6, 0.7
coef(1) c3 = 0.1 ' true value 1 (conditional logit)


' specify likelihood
logl ll3
ll3.append @logl logl3
ll3.append xb1 = a3(1)*stores1+a3(2)*dist1
ll3.append xb2 = a3(1)*stores2+a3(2)*dist2+b3(1)*inc
ll3.append xb3 = a3(1)*stores3+a3(2)*dist3+b3(2)*inc

' inclusive values for each branch
ll3.append ival1 = xb1
ll3.append ival2 = log(exp(xb2)+exp(xb3))

' (unconditional) prob for each brach
ll3.append prob1 = exp(ival1)/( exp(ival1)+exp(c3(1)*ival2) )
ll3.append prob2 = exp(c3(1)*ival2)/( exp(ival1)+exp(c3(1)*ival2) )

' conditional prob within branch 2
ll3.append prob22 = exp(xb2)/( exp(xb2)+exp(xb3) )
ll3.append prob23 = exp(xb3)/( exp(xb2)+exp(xb3) )
ll3.append logl3 = d1*log(prob1) + d2*log(prob2*prob22) + d3*log(prob2*prob23)


' estimate MLE
' check that you get the conditional logit estimates if c3(1)=1
ll3.ml(showopts)
freeze(out1) ll3.output
show out1

' test IIA by testing c3(1)=1
ll3.wald c3(1)=1
